defmodule Gh2ntfy.Ntfyer do
  require Logger

  use GenServer

  def start_link(topic) when is_binary(topic) do
    GenServer.start_link(__MODULE__, topic, name: __MODULE__)
  end

  def send_notif(title, body, headers \\ []) do
    GenServer.cast(__MODULE__, {:send_notif, title, body, headers})
  end

  @impl true
  def init(topic), do: {:ok, topic}

  @impl true
  def handle_cast({:send_notif, title, body, headers}, topic) do
    Logger.info("sending notification with title '#{title}'")

    Finch.build(
      :post,
      "https://" <> Application.fetch_env!(:gh2ntfy, :instance) <> "/" <> topic,
      [
        {"Title", title}
      ] ++ headers,
      body
    )
    |> Finch.request(Gh2ntfy.Finch)

    {:noreply, topic}
  end
end
